MODULE Example2;

FROM Xlib IMPORT DisplayPtr, Window,
		XOpenDisplay, XDefaultScreen, XWhitePixel, XBlackPixel,
		XCreateSimpleWindow, XDefaultRootWindow, XStoreName,
		XEvent, XSelectInput, ExposureMask, XNextEvent,
		XDrawRectangle, XDefaultGC,
		XDrawString,
		XMapRaised, XFlush,
		XDestroyWindow, XCloseDisplay;
FROM InOut IMPORT WriteString, WriteHex, WriteLn;
FROM UxProcesses IMPORT Sleep;
FROM SYSTEM IMPORT CAST;

CONST
  text = "example2.mod?...NO!";

VAR
mydisplay : DisplayPtr;
mywindow : Window;
myscreen : INTEGER;
myforeground, mybackground : CARDINAL ;
myevent : XEvent;
discard : CARDINAL;

BEGIN
WriteString ("Gpm X interface example 2:"); WriteLn;
WriteString ("Open window, draw rectangle, draw text;"); WriteLn;
WriteString (" close after 10 seconds."); WriteLn;

(* Connect to the server: *)
	mydisplay := XOpenDisplay("");
	IF mydisplay = NIL THEN
		WriteString ("Cannot connect to server");
		WriteLn;
		HALT;
	END;
(* Get a screen: *)
	myscreen := XDefaultScreen(mydisplay);
(* Look up "black" and "white": *)
	mybackground := XWhitePixel(mydisplay, myscreen);
	myforeground := XBlackPixel(mydisplay, myscreen);
(* Create a window at (700,50), width 200, height 100: *)
	mywindow := XCreateSimpleWindow(mydisplay,
		XDefaultRootWindow(mydisplay), 700, 50, 200, 100, 2,
		myforeground, mybackground);
(* Give the window manager a window name hint *)
        XStoreName(mydisplay, mywindow, "Gpm Example2");
(* Ask to receive Expose events: *)
	XSelectInput(mydisplay, mywindow, ExposureMask);
(* Pop this window up on the screen: *)
	XMapRaised(mydisplay, mywindow);
(* Get the Expose event caused by mapping the display: *)
	XNextEvent(mydisplay, myevent);
(* Draw a rectangle on mywindow at (10,10), width 50, height 50: *)
	XDrawRectangle(mydisplay, mywindow,
		XDefaultGC(mydisplay, myscreen), 10, 10, 50, 50);
(* Add some text: *)
	XDrawString(mydisplay, mywindow,
		XDefaultGC(mydisplay, myscreen), 10, 80, text, LENGTH(text)-3);
(* Flush the request queue then pause for 10 seconds: *)
	XFlush(mydisplay);
	discard := Sleep(10);
(* Exit gracefully: *)
	XDestroyWindow(mydisplay, mywindow);
	XCloseDisplay(mydisplay);
END Example2.
