MODULE Example3;

FROM Xlib IMPORT None,
		DisplayPtr, Window, XEvent, KeySym,
		XOpenDisplay, XDefaultScreen, XWhitePixel, XBlackPixel,
		XCreateSimpleWindow, XDefaultRootWindow, XStoreName,
		XSelectInput,
		ExposureMask, ButtonPressMask, KeyPressMask,
		Expose, ButtonPress, KeyPress,
		XNextEvent,
		XMapRaised,
		XDrawRectangle, XDefaultGC, XWarpPointer,
		XLookupString,
		XDestroyWindow, XCloseDisplay;

FROM InOut IMPORT WriteString, WriteLn;

VAR
mydisplay : DisplayPtr;
mywindow : Window;
myscreen : INTEGER;
myforeground, mybackground : CARDINAL ;
myevent : XEvent;
text : ARRAY [0..9] OF CHAR;
mykey : KeySym;
i : INTEGER;

BEGIN
WriteString ("Gpm X interface example 3:"); WriteLn;
WriteString ("Open window, enter event loop:"); WriteLn;
WriteString (" - any mouse button press: draw rectangle");
WriteString (" and warp pointer to other corner;"); WriteLn;
WriteString (" - 'q' key: quit."); WriteLn;

(* Connect to the server: *)
	mydisplay := XOpenDisplay("");
	IF mydisplay = NIL THEN
		WriteString ("Cannot connect to server");
		WriteLn;
		HALT;
	END;
(* Get a screen: *)
	myscreen := XDefaultScreen(mydisplay);
(* Look up "black" and "white": *)
	mybackground := XWhitePixel(mydisplay, myscreen);
	myforeground := XBlackPixel(mydisplay, myscreen);
(* Create a window at (600,100), width 250, height 200: *)
	mywindow := XCreateSimpleWindow(mydisplay,
		XDefaultRootWindow(mydisplay), 600, 100, 250, 200, 2,
		myforeground, mybackground);
(* Give the window manager a window name hint *)
        XStoreName(mydisplay, mywindow, "Gpm Example3");
(* Ask to receive Expose, ButtonPress and KeyPress events: *)
	XSelectInput(mydisplay, mywindow, ExposureMask     +
					  ButtonPressMask  +
					  KeyPressMask      );
(* Pop this window up on the screen: *)
	XMapRaised(mydisplay, mywindow);
(* The event loop: *)
	LOOP
		(* Get the next event in the event queue: *)
		XNextEvent(mydisplay, myevent);
		CASE myevent.type OF
		| Expose :
			(* Ignore Expose events *)
		| ButtonPress :
			(* User pressed a pointer button so draw rectangle *)
			XDrawRectangle(mydisplay, mywindow,
				XDefaultGC(mydisplay, myscreen),
				myevent.xbutton.x, myevent.xbutton.y, 50, 50);
			(* Move the cursor relative to (50,50) *)
			XWarpPointer(mydisplay, None, None, 0, 0, 0, 0,
				50, 50);
		| KeyPress :
			(* User pressed a key, see if it's a "q" *)
			i := XLookupString(myevent, text, 10, mykey, 0);
			IF (i=1) AND (text[0]='q') THEN
				EXIT;
			END;
		END;
	END;
(* Exit gracefully: *)
	XDestroyWindow(mydisplay, mywindow);
	XCloseDisplay(mydisplay);
END Example3.
