MODULE Example4;

FROM Xglobal IMPORT int, unsignedInt, unsignedLong, Bool;
FROM Xlib IMPORT None,
		DisplayPtr, Window, XEvent, KeySym,
		XOpenDisplay, XDefaultScreen, XWhitePixel, XBlackPixel,
		XDisplayWidth, XDisplayHeight,
		XCreateSimpleWindow, XDefaultRootWindow, XStoreName,
		XSelectInput,
		ExposureMask, ButtonPressMask, KeyPressMask,
		Expose, ButtonPress, KeyPress,
		XNextEvent,
		XMapRaised,
		XDrawRectangle, XDefaultGC, XWarpPointer,
		XLookupString,
		XQueryPointer,
		XDestroyWindow, XCloseDisplay;

FROM InOut IMPORT WriteString, WriteInt, WriteHex, WriteLn;

VAR
mydisplay : DisplayPtr;
width, height : int;
mywindow : Window;
myscreen : int;
myforeground, mybackground : unsignedLong;
myevent : XEvent;
text : ARRAY [0..9] OF CHAR;
mykey : KeySym;
i : INTEGER;
rootwin, childwin : Window;
xRoot, yRoot, x, y : int;
buttons : unsignedInt;
discardBool : Bool;

BEGIN
WriteString ("Gpm X interface example 4:"); WriteLn;
WriteString ("Open window, enter event loop:"); WriteLn;
WriteString (" - any mouse button press: draw rectangle");
WriteString (" and warp pointer to other corner;"); WriteLn;
WriteString (" - 'q' key: enter infinite loop, reading pointer coordinates");
WriteString (" and buttons,"); WriteLn;
WriteString ("            these are output as x,y (absolute),");
WriteString (" x,y (window relative), buttons;"); WriteLn;
WriteString ("            try moving the example window."); WriteLn;
WriteString (" Kill with crtl-c on DECTerm window."); WriteLn;

(* Connect to the server: *)
	mydisplay := XOpenDisplay("");
	IF mydisplay = NIL THEN
		WriteString ("Cannot connect to server");
		WriteLn;
		HALT;
	END;
(* Get a screen: *)
	myscreen := XDefaultScreen(mydisplay);
(* Look up "black" and "white": *)
	mybackground := XWhitePixel(mydisplay, myscreen);
	myforeground := XBlackPixel(mydisplay, myscreen);
(* Get width and height of root window: *)
	width := XDisplayWidth(mydisplay, myscreen);
	height := XDisplayHeight(mydisplay, myscreen);
(* Create a window based on screen size: *)
	mywindow := XCreateSimpleWindow(mydisplay,
		XDefaultRootWindow(mydisplay), 0, 0, width/3, height/3, 2,
		myforeground, mybackground);
(* Give the window manager a window name hint *)
        XStoreName(mydisplay, mywindow, "Gpm Example4");
(* Ask to receive Expose, ButtonPress and KeyPress events: *)
	XSelectInput(mydisplay, mywindow, ExposureMask     +
					  ButtonPressMask  +
					  KeyPressMask      );
(* Pop this window up on the screen: *)
	XMapRaised(mydisplay, mywindow);
(* The event loop: *)
	LOOP
		(* Get the next event in the event queue: *)
		XNextEvent(mydisplay, myevent);
		CASE myevent.type OF
		| Expose :
			(* Ignore Expose events *)
		| ButtonPress :
			(* User pressed a pointer button so draw rectangle *)
			XDrawRectangle(mydisplay, mywindow,
				XDefaultGC(mydisplay, myscreen),
				myevent.xbutton.x, myevent.xbutton.y, 50, 50);
			(* Move the cursor relative to (50,50) *)
			XWarpPointer(mydisplay, None, None, 0, 0, 0, 0,
				50, 50);
		| KeyPress :
			(* User pressed a key, see if it's a "q" *)
			i := XLookupString(myevent, text, 10, mykey, 0);
			IF (i=1) AND (text[0]='q') THEN
				EXIT;
			END;
		END;
	END;
(* Now loop printing the pointer position: *)
	LOOP
		discardBool := XQueryPointer(mydisplay, mywindow,
			rootwin, childwin, xRoot, yRoot, x, y, buttons);
		WriteInt (xRoot, 12); WriteInt (yRoot, 12);
		WriteInt (x, 12); WriteInt (y, 12);
		WriteHex (buttons, 10);
		WriteLn;
	END;
(* Exit gracefully: *)
	XDestroyWindow(mydisplay, mywindow);
	XCloseDisplay(mydisplay);
END Example4.
