MODULE Example5;

FROM Xglobal IMPORT int, unsignedInt, unsignedLong, Bool;
FROM Xlib IMPORT None,
		DisplayPtr, Window, GC, Font, XEvent, KeySym,
		XOpenDisplay, XDefaultScreen, XWhitePixel, XBlackPixel,
		XDisplayWidth, XDisplayHeight,
		XCreateSimpleWindow, XDefaultRootWindow, XStoreName,
		XCreateGC, XLoadFont, XSetFont,
		XSelectInput,
		ExposureMask, ButtonPressMask, KeyPressMask,
		Expose, ButtonPress, KeyPress,
		XNextEvent,
		XMapRaised,
		XDrawImageString,
		XLookupString,
		XQueryPointer,
		XDestroyWindow, XCloseDisplay;

FROM InOut IMPORT WriteString, WriteInt, WriteHex, WriteLn;
FROM ProgArgs IMPORT ArgNumber, GetArg;
FROM IntStr IMPORT Alignment, Give;
FROM StdStrings IMPORT Append, Length;

VAR
mydisplay : DisplayPtr;
width, height : int;
mywindow : Window;
myscreen : int;
mygc : GC;
myfont : Font;
myforeground, mybackground : unsignedLong;
myevent : XEvent;
text : ARRAY [0..79] OF CHAR;
argv1, moreText : ARRAY [0..20] OF CHAR;
mykey : KeySym;
i : INTEGER;
rootwin, childwin : Window;
xRoot, yRoot, x, y : int;
buttons : unsignedInt;
discardBool : Bool;

BEGIN
WriteString ("Gpm X interface example 5:"); WriteLn;
WriteString ("Usage: example5 [font_identifier]"); WriteLn;
WriteString ("Open window, enter event loop:"); WriteLn;
WriteString (" - any mouse button press: display pointer coordinates");
WriteString ("  in example window,"); WriteLn;
WriteString ("                           x,y absolute, x,y window relative;");
WriteLn;
WriteString (" - 'q' key: quit."); WriteLn;
WriteString ("Try default font, then some like 6x10, 8x13bold,");
WriteString (" rot-s16, vsgn-57, vshd-40.");
WriteLn;

(* Connect to the server: *)
	mydisplay := XOpenDisplay("");
	IF mydisplay = NIL THEN
		WriteString ("Cannot connect to server");
		WriteLn;
		HALT;
	END;
(* Get a screen: *)
	myscreen := XDefaultScreen(mydisplay);
(* Look up "black" and "white": *)
	mybackground := XWhitePixel(mydisplay, myscreen);
	myforeground := XBlackPixel(mydisplay, myscreen);
(* Get width and height of root window: *)
	width := XDisplayWidth(mydisplay, myscreen);
	height := XDisplayHeight(mydisplay, myscreen);
(* Create a window based on screen size: *)
	mywindow := XCreateSimpleWindow(mydisplay,
		XDefaultRootWindow(mydisplay), 200, 500, 2*width/3, height/2, 2,
		myforeground, mybackground);
(* Give the window manager a window name hint *)
        XStoreName(mydisplay, mywindow, "Gpm Example5");
(* Create a GC: *)
	mygc := XCreateGC(mydisplay, mywindow, 0, NIL);
(* Set current font to specified font: *)
	IF ArgNumber()=2 THEN
		GetArg (1, argv1);
		myfont := XLoadFont(mydisplay, argv1);
		IF myfont<>0 THEN
			XSetFont(mydisplay, mygc, myfont);
		END;
	END;
(* Ask to receive Expose, ButtonPress and KeyPress events: *)
	XSelectInput(mydisplay, mywindow, ExposureMask     +
					  ButtonPressMask  +
					  KeyPressMask      );
(* Pop this window up on the screen: *)
	XMapRaised(mydisplay, mywindow);
(* The event loop: *)
	LOOP
		(* Get the next event in the event queue: *)
		XNextEvent(mydisplay, myevent);
		CASE myevent.type OF
		| Expose :
			(* Ignore Expose events *)
		| ButtonPress :
			(* User pressed a pointer button *)
			(* Convert the button coordinates to a string *)
			Give (text, myevent.xbutton.xRoot, 5, right);
			Append (" ", text);
			Give (moreText, myevent.xbutton.yRoot, 5, right);
			Append (moreText, text);
			Append (", ", text);
			Give (moreText, myevent.xbutton.x, 5, right);
			Append (moreText, text);
			Append (" ", text);
			Give (moreText, myevent.xbutton.y, 5, right);
			Append (moreText, text);
			(* Show the image string at the pointer coordinates
			*)
			XDrawImageString(mydisplay, mywindow, mygc,
				myevent.xbutton.x, myevent.xbutton.y,
				text, Length(text));
		| KeyPress :
			(* User pressed a key, see if it's a "q" *)
			i := XLookupString(myevent, text, 10, mykey, 0);
			IF (i=1) AND (text[0]='q') THEN
				EXIT;
			END;
		END;
	END;
(* Exit gracefully: *)
	XDestroyWindow(mydisplay, mywindow);
	XCloseDisplay(mydisplay);
END Example5.
