MODULE MakeRamp;
(* Construct a colour database which interpolates two limit values *)

IMPORT StdError;
FROM InOut IMPORT WriteString, ReadCard, WriteCard, WriteLn;

VAR
  red1, green1, blue1, red2, green2, blue2, numSteps, step, stepCopy : CARDINAL;
  redInc, greenInc, blueInc : REAL;

BEGIN
  StdError.WriteString ("First end colour (r g b, each 0..65535) : ");
  ReadCard (red1);
  ReadCard (green1);
  ReadCard (blue1);
  StdError.WriteString ("Second end colour (r g b, each 0..65535) : ");
  ReadCard (red2);
  ReadCard (green2);
  ReadCard (blue2);
  StdError.WriteString ("Number of steps : ");
  ReadCard (numSteps);
  redInc := (FLOAT(red2) - FLOAT(red1)) / FLOAT(numSteps-1);
  greenInc := (FLOAT(green2) - FLOAT(green1)) / FLOAT(numSteps-1);
  blueInc := (FLOAT(blue2) - FLOAT(blue1)) / FLOAT(numSteps-1);
  WriteCard (red1, 6);
  WriteCard (green1, 6);
  WriteCard (blue1, 6);
  WriteLn;
  FOR step := 1 TO numSteps-1 DO
    stepCopy := step;
    WriteCard (TRUNC(FLOAT(red1) + redInc * FLOAT(stepCopy)), 6);
    WriteCard (TRUNC(FLOAT(green1) + greenInc * FLOAT(stepCopy)), 6);
    WriteCard (TRUNC(FLOAT(blue1) + blueInc * FLOAT(stepCopy)), 6);
    WriteLn;
  END;
  WriteLn;
END MakeRamp.
